
## if given fileName is not available then it throws FileNotFoundError
'''
print('start line')

open('demo.txt', "r")

print('end line')
'''

## if given fileName is available then it creates file Object
'''
print('start line')

fileObject = open('demo.txt', "r")
print(fileObject)
print("File Name is :",fileObject.name)
print("File Mode is :",fileObject.mode)
print(fileObject.closed)
print('end line')
'''

## How to access the fileData using fileObject?
'''
fileObject = open('demo.txt', "r")

for i in fileObject:
    print(i, end="\n")
'''

# What is output?
'''
fileObject = open('demo.txt', "r")

for i in fileObject:
    print(i, end="")

'''

### working with "read()"  method
'''
fileObject = open('demo.txt', "r")

data = fileObject.read() ## returns like "multiline string"
print(data)  
'''

## How to return list of words and total words count using given file ?
'''
fileObject = open('demo.txt', "r")

data = fileObject.read() ## returns like "multiline string"
print(data.split())
print("Totally",len(data.split()),"words available")
'''

## How to return list of lines and total lines count using given file ?
'''
fileObject = open('demo.txt', "r")

data = fileObject.read() ## returns like "multiline string"
print(data.splitlines())
print("Totally",len(data.splitlines()),"lines available")
'''

## Shortest way
'''
print(open('demo.txt', "r").read())

print(open('demo.txt', "r").read().split())

print(len(open('demo.txt', "r").read().split()))
'''


## read(count)
'''
fileObject = open('demo.txt', "r")

data = fileObject.read(4) # it returns only given count number of charecters.
print(data)

data2 = fileObject.read() 
print(data2)
'''

## realine()
'''
fileObject = open('demo.txt', "r")

data = fileObject.readline() # it returns current line from file pointer position
print(data, end="")
'''

## realine(count)
'''
fileObject = open('demo.txt', "r")

data = fileObject.readline(4) #
print(data)

data = fileObject.readline() #
print(data, end="")
'''

##  readlines()
'''
fileObject = open('demo.txt', "r")

data = fileObject.readlines() # it returns list of lines 
print(data)
'''
## Shortest way
'''
print(open('demo.txt', "r").readlines())

print(len(open('demo.txt', "r").readlines()))
'''

##  readlines(count)
'''
fileObject = open('demo.txt', "r")

data = fileObject.readlines(2) # it returns list of current single line 
print(data)
'''

## How to accesss the last line last word  first charecter
'''
print(open('demo.txt', "r").readlines()[-1].split()[-1][0])
'''

## if fileObject is closed then if traying to access the data from a file then it throws below exception
# ValueError: I/O operation on closed file.
'''
fileObject = open('demo.txt', "r")

data = fileObject.read(4)
print(data)

fileObject.close()
print(fileObject.read(4)) # ValueError: I/O operation on closed file.
'''

###
#### Writting the data into a file  #####
###


### working with "w"  mode ###

## if given fileName is not available then it creates new file
'''
print('start line')

fileObject = open('demo2.txt', 'w')

print(fileObject)

print('end line')
'''

## if given fileName is already available then it truncates it and creates new file
'''
print('start line')

fileObject = open('demo3.txt', 'w')

print(fileObject)

print('end line')
'''

## if fileObject is not closing then we can not see the data in a file
'''
print('start line')

fileObject = open('demo4.txt', 'w')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
print('Data added in a file successfully!')

print('end line')
'''

## if fileObject is closing after adding data then we can see the data in a file
'''
print('start line')

fileObject = open('demo5.txt', 'w')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''

##
### working with "x" (exclusive)  mode ###
##


## if given fileName is not available then it will creates it and we can add data
'''
print('start line')

fileObject = open('demo6.txt', 'x')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''

## if given fileName is already available then it will throws exception like FileExistsError]
'''
print('start line')

fileObject = open('demo6.txt', 'x')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''


##
### working with "a" (append)  mode ###
##


## if given fileName is not available then it will creates it and we can add data
'''
print('start line')

fileObject = open('demo7.txt', 'a')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''

## if given fileName is already available then it will use same file and adding new data at end position
'''
print('start line')

fileObject = open('demo7.txt', 'a')

fileObject.write("\nDjango is follows MVT architecture")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''



### Identify the Output

## if any exception raised before closing the fileObject then we are unable to see the data in a file
'''
print('start line')

fileObject = open('demo8.txt', 'w')

fileObject.write("\nDjango is follows MVT architecture")
print('Data added in a file successfully!')

x = 10
y = 0
z = x / y 

fileObject.close()

print('end line')
'''

## How to overcome the above proble ?

# Note:  by using "with" keyword if open the fileName and creating fileObject.
'''
print('start line')

with open('demo9.txt', 'w') as fileObject:
    fileObject.write("Django is follows MVT architecture")
    print('Data added in a file successfully!')

x = 10
y = 0
z = x / y 

fileObject.close()

print('end line')
'''

## Write a program to Counting number of vowels in the file ?
'''
fileObject = open('demo.txt', "r")
data = fileObject.read()

vowels = 'aeiouAEIOU'
count = 0
for i in data:
    if i in vowels:
        count = count + 1
        
print(count)       
'''

## finding each vowel count?
'''
fileObject = open('demo.txt', "r")
data = fileObject.read()

vowels = 'aeiouAEIOU'
vowels_dict = {}

for i in data:
    if i in vowels:
        if i not in vowels_dict:
            vowels_dict[i] = 1
        else:
            vowels_dict[i] = vowels_dict[i] + 1
            
print(vowels_dict)
'''

### working with "tell()" and "seek()"  methods
'''
fileObject = open('demo.txt', "r")
print("Initially File pointer position is :",fileObject.tell())

data = fileObject.read(4)
print(data)
print("Aftert accessing data, file pointer position is :",fileObject.tell())

fileObject.seek(0)
print("Aftert using seek(), file pointer position is :",fileObject.tell())

data = fileObject.read(4)
print(data)
'''


#####  Working with  predefined "os"  module #####
'''
import os
print(os.getcwd())
'''

## listdir()
'''
import os
print(os.listdir())
'''

## rename("old_fileName1", "new_fileName2")

# if given old fileName is available then it renames with given new fileName
'''
import os
os.rename('sample1.txt', 'sample2.txt')
print('file name renamed successfully!')
'''

# if given old fileName is not available then it throws exception like FileNotFoundError
'''
import os
os.rename('sample3.txt', 'sample2.txt')
print('file name renamed successfully!')
'''

## remove('fileName')

# if given fileName is not available then it throws exception like FileNotFoundError
'''
import os
os.remove('sample3.txt')
print('file removed successfully!')
'''

# if given fileName is available then it will delete it
'''
import os
os.remove('sample2.txt')
print('file removed successfully!')
'''













